<img src="/static/img/nylas-sdk-cuub@2x.png" class="center-logo"/>
<h2 style="text-align:center; margin-top:-20px;">Nylas SDK</h2>
<p style="text-align:center; margin:auto; margin-bottom:60px;">The Nylas SDK allows you to create powerful extensions to N1, a mail client for Mac OS X, Windows, and Linux. Building on N1 saves time and allows you to build innovative new experiences fast.<br>
<a href="http://nylas.github.io/N1/docs/GettingStartedPart1.html" class="btn btn-redwood btn-sm btn-light btn-shadowed">Get Started</a>
</p>

<table class="no-border">
<tr><td style="width:50%;">

<h4>Installing N1</h4>
<p>
N1 is available for Mac, Windows, and Linux. Download the latest build for your platform below:
</p>
<ul>
<li><a href="https://edgehill.nylas.com/download?platform=darwin">Mac OS X</a></li>
<li><a href="https://edgehill.nylas.com/download?platform=linux">Linux</a></li>
<li><a href="https://edgehill.nylas.com/download?platform=win32">Windows</a></li>
</ul>

</td><td style="width:50%;">

<h4>Package Architecture</h4>
<p>
Packages lie at the heart of N1. Each part of the core experience is a separate package that uses the Nylas Package API to add functionality to the client. Learn more about packages and create your first package.
</p>
<ul>
<li><a href="http://nylas.github.io/N1/docs/GettingStartedPart1.html">Create a Plugin</a></li>
<li><a href="http://nylas.github.io/N1/docs/PackageOverview.html">Plugin Overview</a></li>
</ul>

</td></tr>
<tr><td style="width:50%; vertical-align:top;">

<h4>Dive Deeper</h4>

<ul>
<li><a href="http://nylas.github.io/N1/docs/Architecture.html">Application Architecture</a></li>
<li><a href="http://nylas.github.io/N1/docs/React.html">React & Component Injection</a></li>
<li><a href="http://nylas.github.io/N1/docs/InterfaceConcepts.html">Core Interface Concepts</a></li>
<li><a href="http://nylas.github.io/N1/docs/Database.html">Accessing the Database</a></li>
<li><a href="http://nylas.github.io/N1/docs/DraftStoreExtension.html">Draft Store Extensions</a></li>
</ul>

</td><td style="width:50%; vertical-align:top;">

<h4>Debugging Packages</h4>
<p>
N1 is built on top of Electron, which runs the latest version of Chromium. Learn how to access debug tools in Electron and use our Developer Tools Extensions:
</p>
<ul>
<li><a href="http://nylas.github.io/N1/docs/Debugging.html">Debugging in Nylas</a></li>
</ul>

</td></tr>
<tr colspan="2"><td>
<h4>Questions?</h4>
<p>
Need help? Check out the <a href="https://support.nylas.com/hc/en-us">FAQ</a> or post a question in the <a href="http://slack-invite.nylas.com/">slack channel</a>.
</p>

</td></tr>
</table>
